var camCtrl;
var uiCtrl;
var buildCtrl;
var rayCtrl;
var _canvas;
var _engine;
var _scene;

var objCircle;

var id;

var leftPic;
var rightPic;
var centerPV;

var mp4Url = "";

window.onload = function(){
    if(!ToolMgr.isMobel()){
        let link = document.getElementById('linkcss');
        link.href = "http://exhibition.szwyg.org.cn/resources/opening_ceremony/res/css/style.css";
    }
    let params = ToolMgr.getParams(location.search);
    //params.id=1;
    if(params && params.id){
        id = params.id;
        initEnv();
        _engine.runRenderLoop(function () {
            _scene.render();
            TWEEN.update();
            // console.log(_engine.getFps());
        });
    }
    else{
        alert("入参xx.html?id=1不存在");
    }
}
window.addEventListener("resize", function (ev) {
    if(_engine){
        _engine.resize();
    }
});
function initEnv() {
    _canvas = document.getElementById("renderCanvas");
    if(ToolMgr.isMobel()){
        _engine = new BABYLON.Engine(_canvas, true);
    }
    else {
        _engine = new BABYLON.Engine(_canvas, true);
    }
    _scene = new BABYLON.Scene(_engine);
     _scene.environmentTexture = new BABYLON.HDRCubeTexture("http://exhibition.szwyg.org.cn/resources/opening_ceremony/res/hdr/1.hdr", _scene, 128, false, true, false, true);
    _scene.environmentIntensity = 1;
    _scene.gravity = new BABYLON.Vector3(0, -0.9, 0);
    _scene.collisionsEnabled = true;

    var light = new BABYLON.HemisphericLight("HemiLight", new BABYLON.Vector3(0, 1, 0), _scene);
    light.intensity = 1;
    initCtrl();
    DataConfig.getAllData(id, (datas)=> {
        //加载模型
        buildCtrl.loadBuildModel("http://exhibition.szwyg.org.cn/resources/opening_ceremony/res/models/", "kms.glb", (value) => {
            uiCtrl.setProgress(value + "%")
        }, () => {
            uiCtrl.loadFinish();
            for(let i = 0; i < datas.rooms.length; i++){
                if(datas.rooms[i].number == 1){
                  console.log(datas.rooms[i]);
                  for(let j = 0; j < datas.rooms[i].exhibits.length; j++) {
                      let exhibit = datas.rooms[i].exhibits[j]
                      if (exhibit.number == 2 && exhibit.url.match(".mp4")) {
                        mp4Url = exhibit.url;
                      } else {
                        if (exhibit.number == 1) {
                            let tex = new BABYLON.Texture(exhibit.url, _scene, false, true, BABYLON.Texture.TRILINEAR_SAMPLINGMODE,()=>{
                                let mat = leftPic.material.clone();
                                mat.albedoTexture = tex;
                                mat.albedoColor.r = 1;
                                mat.albedoColor.g = 1;
                                mat.albedoColor.b = 1;
                                tex.vScale = -1;
                                leftPic.material = mat;
                            });
                        } else if (exhibit.number == 2) {
                            let tex = new BABYLON.Texture(exhibit.url, _scene, false, true, BABYLON.Texture.TRILINEAR_SAMPLINGMODE,()=>{
                                let mat = centerPV.material.clone();
                                mat.albedoTexture = tex;
                                mat.albedoColor.r = 1;
                                mat.albedoColor.g = 1;
                                mat.albedoColor.b = 1;
                                tex.vScale = -1;
                                centerPV.material = mat;
                            });
                        } else if (exhibit.number == 3) {
                            let tex = new BABYLON.Texture(exhibit.url, _scene, false, true, BABYLON.Texture.TRILINEAR_SAMPLINGMODE,()=>{
                                let mat = rightPic.material.clone();
                                mat.albedoTexture = tex;
                                mat.albedoColor.r = 1;
                                mat.albedoColor.g = 1;
                                mat.albedoColor.b = 1;
                                tex.vScale = -1;
                                rightPic.material = mat;
                            });
                        }
                      }
                  }
                  break;
                }
            }
        });
        createCircle();
    });
}
function initCtrl() {
    //相机控制
    camCtrl = new CamCtrl(_canvas, _scene);
    camCtrl.awake();

    //射线检测
    rayCtrl = new RaycastCtrl(_canvas, _scene);
    rayCtrl.awake();
    //建筑
    buildCtrl = new BuildCtrl(_scene);
    uiCtrl = new UICtrl();
}
function createCircle(){
    let mat = new BABYLON.StandardMaterial("circleMat", _scene);
    mat.emissiveTexture = new BABYLON.Texture("http://exhibition.szwyg.org.cn/resources/opening_ceremony/res/textures/circle.png", _scene);
    mat.opacityTexture = mat.emissiveTexture;
    mat.emissiveTexture.hasAlpha = true;
    mat.hasAlpha = true;
    mat.disableLighting = true;
    mat.environmentIntensity = 0;

    objCircle = BABYLON.Mesh.CreateGround("obj", 0.05, 0.05, 2, _scene);
    objCircle.position.y += 0.001;
    objCircle.material = mat;
    objCircle.position.x = 10;
}

//播放视频
function playPingMu(url) {
    if (centerPV) {
        //pingmu.scaling.z = -1;
        //pingmu.position.x = 5;
        var ANote0VideoMat = centerPV.material;
        let ANote0VideoVidTex = new BABYLON.VideoTexture("vidtex", url, _scene);//, false, false, BABYLON.TRILINEAR_SAMPLINGMODE , { autoUpdateTexture:true, loop:true});
        ANote0VideoVidTex.video.autoPlay = false;
        //ANote0VideoVidTex.video.muted=true;
        ANote0VideoVidTex.video.autoUpdateTexture = true;
        ANote0VideoVidTex.video.loop = true;

        //ANote0VideoVidTex.vScale = -1;
        ANote0VideoVidTex.video.play();
        ANote0VideoVidTex.video.addEventListener('play', function () { //
            console.log("播放开始");
            centerPV.scaling.x = -0.1;
            ANote0VideoMat.albedoTexture = ANote0VideoVidTex;
            ANote0VideoMat.albedoColor = new BABYLON.Color3.White();
        }, false);
    }
}

function enter() {
    location.href='/exhibition?id='+id+"&enter=1"
}
////播放视频
//function playPingMu(url){
//    if(centerPV){
//        //pingmu.scaling.z = -1;
//        //pingmu.position.x = 5;
//        var ANote0VideoMat = centerPV.material;
//        let ANote0VideoVidTex = new BABYLON.VideoTexture("vidtex",url, _scene);//, false, false, BABYLON.TRILINEAR_SAMPLINGMODE , { autoUpdateTexture:true, loop:true});
//        ANote0VideoVidTex.video.autoPlay = true;
//        //ANote0VideoVidTex.video.muted=true;
//        ANote0VideoVidTex.video.autoUpdateTexture = true;
//        ANote0VideoVidTex.video.loop = true;
//        ANote0VideoMat.albedoTexture = ANote0VideoVidTex;
//        ANote0VideoMat.albedoColor = new BABYLON.Color3.White();
//        ANote0VideoVidTex.vScale = -1;
//    }
//}
